#20211126, SVGパス情報を読み取って長さなどを計算、対応コマンドM,m,H,h,V,v,L,l,C,c, 扇形2枚の範囲に入っているか判定
#扇形図形の中心座標cxyの計算を修正
#ファイルリストの１行目のファイルを開いて、出力ファイルは同名のcsvにする
inputfilepath <- scan(file = "filelist.txt", what = character(), sep = "\n", skip=0, blank.lines.skip = FALSE, nlines=1)
outfilepath <- gsub(".svg", ".csv", inputfilepath)
if(length(inputfilepath) == 0){print("SVG file is not found"); stop()}
txtall <- scan(file = inputfilepath, what = character(), sep = "\n", skip=0, blank.lines.skip = FALSE)
#SVGファイルの中のパス情報の抽出
g1 <- which(txtall == "    <path")
#pathがない場合停止
if(length(g1) == 0){print("There are no fibers"); stop()}
g2 <- sort(unique(c(g1, (g1+1), (g1+2), (g1+3), (g1+4))))
g3 <- intersect(g2, which(substr(txtall, 1, 10) == "       id="))
g4 <- intersect(g2, which(substr(txtall, 1, 9) == "       d="))
g5 <- intersect(g2, which(substr(txtall, 1, 13) == "       style="))
gptxt <- substr(txtall[g4], 11, nchar(txtall[g4]))
gptxt <- gsub("z\"", "zend", gptxt); gptxt <- gsub("Z\"", "zend", gptxt); gptxt <- gsub("\"", " end", gptxt)
gsepn <- nchar(gptxt) - nchar(gsub(" ", "", gptxt))
gn <- c(1:length(gptxt)); gn <- rep(gn, (gsepn+1))
gpend <- substr(gptxt, nchar(gptxt)-3, nchar(gptxt)); gpend <- gsub(" ", "", gpend)
comlist <- c("m", "M", "l", "L", "h", "H", "v", "V", "end", "zend", "c", "C")
gptxtsp <- unlist(strsplit(gptxt, " "))
gmat1 <- match(gptxtsp, comlist)
gmat2 <- rep(1, length(gptxtsp)); gmat2[which(is.na(gmat1))] <- 0; gmat2 <- cumsum(gmat2)
gmat3 <- gmat1[-1*which(is.na(gmat1))]; gmat3 <- gmat3[gmat2]
gmat4 <- cbind(comlist[gmat3], gptxtsp)
for(j in c(length(gptxtsp):3)){
if((gmat4[j,1] == "M") && (gmat4[j-1,1] == "M") && (gmat4[j-2,1] == "M")){
gmat4[j,1] <- "L"
}else if((gmat4[j,1] == "m") && (gmat4[j-1,1] == "m") && (gmat4[j-2,1] == "m")){
gmat4[j,1] <- "l"
}
}
gmat4 <- gmat4[which(is.na(gmat1)),]
gn <- gn[which(is.na(gmat1))]
vadd <- rep("", nrow(gmat4)); vadd[which(gmat4[,1] == "v")] <- "0,"; vadd[which(gmat4[,1] == "V")] <- "0,"
hadd <- rep("", nrow(gmat4)); hadd[which(gmat4[,1] == "h")] <- ",0"; hadd[which(gmat4[,1] == "H")] <- ",0"
gmat4[,2] <- paste(vadd, gmat4[,2], hadd, sep="")
#SVGに使われるコマンド文字の解釈と座標算出
gmat5 <- t(matrix(unlist(strsplit(gmat4[,2], ",")), nrow=2)); mode(gmat5) <- "numeric"
gdxy <- matrix(0, nrow(gmat5), 4); gdxy[1,] <- c(gmat5[1,], 1, gn[1])
gdxyadd <- matrix(0, nrow(gmat5)*8, 4); gdxyadd[1,] <- c(gmat5[1,], 1, gn[1])
cflag <- 0
k <- 2; ka <- 2
octamat <- t(matrix(c(343,147,21,1,27,27,9,1,125,225,135,27,1,3,3,1,27,135,225,125,1,9,27,27,1,21,147,343,0,0,0,1),4,8))
for(j in c(2:nrow(gmat5))){
if((gmat4[j,1] == "m") || (gmat4[j,1] == "M") || (gmat4[j,1] == "L")){
gdxy[k,] <- c(gmat5[j,], j, gn[j]); gdxyadd[ka,] <- c(gmat5[j,], j, gn[j])
k <- k + 1; ka <- ka + 1
}else if((gmat4[j,1] == "H")){
gdxy[k, 1] <- gmat5[j, 1]; gdxy[k, 2] <- gdxy[(k-1), 2]; gdxy[k, 3] <- j; gdxy[k, 4] <- gn[j]
gdxyadd[ka, 1] <- gmat5[j, 1]; gdxyadd[ka, 2] <- gdxyadd[(ka-1), 2]; gdxyadd[ka, 3] <- j; gdxyadd[ka, 4] <- gn[j]
k <- k + 1; ka <- ka + 1
}else if((gmat4[j,1] == "V")){
gdxy[k, 1] <- gdxy[(k-1), 1]; gdxy[k, 2] <- gmat5[j, 2]; gdxy[k, 3] <- j; gdxy[k, 4] <- gn[j]
gdxyadd[ka, 1] <- gdxyadd[(ka-1), 1]; gdxyadd[ka, 2] <- gmat5[j, 2]; gdxyadd[ka, 3] <- j; gdxyadd[ka, 4] <- gn[j]
k <- k + 1; ka <- ka + 1
}else if((gmat4[j,1] == "l") || (gmat4[j,1] == "h") || (gmat4[j,1] == "v")){
gdxy[k,] <- c( (gdxy[(k-1), c(1,2)] + gmat5[j,]), j, gn[j])
gdxyadd[ka,] <- c( (gdxyadd[(ka-1), c(1,2)] + gmat5[j,]), j, gn[j])
k <- k + 1; ka <- ka + 1
}else if((gmat4[j,1] == "C") || (gmat4[j,1] == "c")){
if(gmat4[j,1] != gmat4[j-1,1]){ cflag == 0; print(gmat4[c(j-1, j), 1]) }
if(cflag == 0){
cflag <- cflag + 1
if(gmat4[j,1] == "C"){param1 <- gmat5[j,]}else{param1 <- gdxy[(k-1), c(1,2)] + gmat5[j,]}
}else if(cflag == 1){
cflag <- cflag + 1
if(gmat4[j,1] == "C"){param2 <- gmat5[j,]}else{param2 <- gdxy[(k-1), c(1,2)] + gmat5[j,]}
}else if(cflag == 2){
if(gmat4[j,1] == "C"){
gdxy[k,] <- c(gmat5[j,], j, gn[j])
paramat <- rbind(gdxyadd[(ka-1), c(1,2)], param1, param2, gmat5[j,])
}else{
gdxy[k,] <- c( (gdxy[(k-1), c(1,2)] + gmat5[j,]), j, gn[j])
paramat <- rbind(gdxyadd[(ka-1), c(1,2)], param1, param2, (gdxyadd[(ka-1), c(1,2)] + gmat5[j,]))
}
xys <- octamat%*%paramat
xys <- sweep(xys, 1, apply(octamat, 1, sum), FUN="/")
gdxyadd[c((ka):(ka+7)), ] <- cbind(xys, rep(j, 8), rep(gn[j], 8))
k <- k + 1
ka <- ka + 8
cflag <- 0
}
}else{
print(paste("Unsupported command ", gmat4[j,1], " appear at ", j, sep=""))
stop()
}
}
gdxy <- gdxy[which(gdxy[,3] != 0),]
gdxyadd <- gdxyadd[which(gdxyadd[,3] != 0),]
#集計表の作成
gn2st <- which(c(0, gdxyadd[,4]) != c(gdxyadd[,4], 0))
gn2ed <- gn2st[c(2:length(gn2st))] - 1; gn2st <- gn2st[c(1:(length(gn2st)-1))]
gdxyleng <- rbind(gdxyadd[c(2:nrow(gdxyadd)),c(1,2)], c(0,0))
gdxyleng[gn2ed,] <- gdxyadd[gn2st,c(1,2)]
gdxyleng <- sqrt( apply((gdxyadd[,c(1,2)] - gdxyleng)^2, 1, sum) )
totallength <- tapply(gdxyleng, gdxyadd[,4], sum)
lenrate <- (gdxyleng[gn2ed] / totallength)*100
fibres <- (gdxyleng[gn2ed] >= 5)*1 + (lenrate >= 10)*1
gpend2 <- rep("Particle2", max(gdxyadd[,4])); gpend2[which(fibres == 2)] <- "Fiber"
gpend2[which(gpend == "zend")] <- "Particle1"
gcode <- substr(txtall[g5], regexpr("#", txtall[g5]), regexpr("#", txtall[g5])+6); table(gcode)
colorcode <- cbind(c("#ff0000","#ffff00","#00ff00","#00ffff","#ff00ff","#0000ff","#ffffff","#000000"),c("Red","Yellow","Green","Cyan","Magenta","Blue","White","Black"))
gcolname <- cbind(gcode, colorcode[match(gcode, colorcode[,1]), 2])
gpn <- substr(txtall[g3], 12, nchar(txtall[g3])); gpn <- substr(gpn, 1, (regexpr("\"", gpn)-1))
#x,y,ne,nw方向の最長距離
x1width <- tapply(gdxyadd[,1], gdxyadd[,4], max) - tapply(gdxyadd[,1], gdxyadd[,4], min)
y1width <- tapply(gdxyadd[,2], gdxyadd[,4], max) - tapply(gdxyadd[,2], gdxyadd[,4], min)
rotn <- 45; rotmat <- matrix(c(cos(2*pi*rotn/360), -1*sin(2*pi*rotn/360), sin(2*pi*rotn/360), cos(2*pi*rotn/360)), 2, 2)
gdxycenter <- apply(gdxyadd[,c(1,2)], 2, mean)
gdxyrot <- sweep(gdxyadd[,c(1,2)], 2, gdxycenter, FUN="-")%*%rotmat
newidth <- tapply(gdxyrot[,1], gdxyadd[,4], max) - tapply(gdxyrot[,1], gdxyadd[,4], min)
nwwidth <- tapply(gdxyrot[,2], gdxyadd[,4], max) - tapply(gdxyrot[,2], gdxyadd[,4], min)
#面積計算
u1 <- (c(0, gdxyadd[,4]) == c(gdxyadd[,4], 0))*1
u2 <- 2*c(1:length(u1))
u3 <- u2[which(u1 == 0)] - 1; u3 <- u3[-1]
u2 <- u2[-1*length(u2)]
odr <- order(c(u2, u3))
dx <- rbind(gdxyadd, gdxyadd[gn2st,]); dx <- dx[odr,]
u4 <- which(c(0, dx[,4]) != c(dx[,4], 0))*1; u4 <- u4[-1*length(u4)]
ds <- dx[c(1:(nrow(dx)-1)),1]*dx[c(2:(nrow(dx))),2] - dx[c(2:(nrow(dx))),1]*dx[c(1:(nrow(dx)-1)),2]
ds <- c(0, ds); ds[u4] <- 0
dl <- sqrt( (dx[c(2:(nrow(dx))),1]-dx[c(1:(nrow(dx)-1)),1])^2 + (dx[c(2:(nrow(dx))),2]-dx[c(1:(nrow(dx)-1)),2])^2 )
dl <- c(0, dl); dl[u4] <- 0
dss <- abs(tapply(ds, dx[,4], sum))/2
dll <- tapply(dl, dx[,4], sum)
#扇形2枚の領域に入っているかどうか判定
if(length(which(txtall == "    <g")) == 1){
g6 <- seq(which(txtall == "    <g"), g6 <- which(txtall == "    </g>"), 1)
g6txy <- intersect(g6, which(substr(txtall, 1, 17) == "       transform="))
g6txy <-  as.numeric(unlist(strsplit(substr(txtall[g6txy], (regexpr("\\(", txtall[g6txy])+1), regexpr("\\)", txtall[g6txy])-1), ",")))
if(length(g6txy) == 2){g6txy <- c(1, 0, 0, 1, g6txy)}
g6cx <- intersect(g6, which(substr(txtall, 1, 21) == "         sodipodi:cx="))
g6cy <- intersect(g6, which(substr(txtall, 1, 21) == "         sodipodi:cy="))
cxy <- as.numeric(substr(txtall[c(g6cx[1], g6cy[1])], 23, nchar(txtall[c(g6cx[1], g6cy[1])])-1))
cxy <- c(cxy[1]*g6txy[1] + cxy[2]*g6txy[3] + g6txy[5], cxy[1]*g6txy[2] + cxy[2]*g6txy[4] + g6txy[6])
rxy <- sqrt(apply(sweep(gdxyadd[,c(1,2)], 2, cxy, FUN="-")^2, 1, sum))
anglexy <- 180/pi*acos((gdxyadd[,1]-cxy[1])/rxy)
anglexy[which((gdxyadd[,2]-cxy[2])<0)] <- 360 - anglexy[which((gdxyadd[,2]-cxy[2])<0)]
pmxy <- sweep(gdxyadd[,c(1,2)], 2, cxy, FUN="-")
pmyy <- ((pmxy[,2]*c(0, pmxy[c(1:(nrow(pmxy)-1)), 2])) < 0)*1
pmyy <- pmyy*(pmxy[,1] > 0)*1
pmyy <- pmyy*(c(0, pmxy[c(1:(nrow(pmxy)-1)), 1]) > 0)*1
pmyy[gn2st] <- 0
alternums <- gdxyadd[which(pmyy == 1), 4]
anglexysted <- cbind(anglexy[gn2st], anglexy[gn2ed])
anglexysted[alternums,] <- anglexysted[alternums,]*-1
anglexysteduse <- gn2st; anglexysteduse[which(anglexysted[,1] > anglexysted[,2])] <- gn2ed[which(anglexysted[,1] > anglexysted[,2])]
anglexystedmin <- anglexy[anglexysteduse]
anglexystedmin <- cbind(anglexystedmin, anglexystedmin + 360)
#8エリアのどこに所属するか判定
anglehit <- rep(0, length(g1))
for(aj in c(1:8)){
j <- 22.5*(aj-1)
anglehit <- anglehit + apply((j <= anglexystedmin)*(anglexystedmin < (j + 22.5)), 1, sum)*aj
k <- 360*1/2; anglehit <- anglehit + apply(((j+k) <= anglexystedmin)*(anglexystedmin < (j + 22.5+k)), 1, sum)*aj
}
stedxy <- gdxyadd[anglexysteduse, c(1,2), drop=FALSE]
#扇形図形がない場合
}else{
anglehit <- rep("-", length(g1))
stedxy <- gdxyadd[gn2ed, c(1,2), drop=FALSE]
}
#出力
outs <- cbind(c(1:length(g1)), gpn, gcolname, (totallength - gdxyleng[gn2ed]), gdxyleng[gn2ed], anglehit, stedxy[,1], stedxy[,2])
write.table(matrix(c("N","path","code","color","length","startend","LocateInSector", "X", "Y"), nrow=1), file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE)
write.table(outs, file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE, append=TRUE)
write.table("--", file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE, append=TRUE)
write.table(cbind(gdxyadd[,4], gpn[gdxyadd[,4]], gdxyadd[,c(1,2)]), file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE, append=TRUE)
write.table("--", file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE, append=TRUE)
write.table(txtall[g2], file=outfilepath, sep=",", row.names=FALSE, col.names=FALSE, quote=FALSE, append=TRUE)
